using System;
using System.IO;
using System.Net;
using System.Text;

namespace Appoint
{
  class AppointMain
  {
    public static void Main(string[] args)
    {

      string HOST = "localhost";
      string PORT = "8000";
      string USER = "ormaster";
      string PASSWD = "ormaster";
      string CONTENT_TYPE = "application/xml";

      string URL = "http://" + HOST + ":" + PORT + "/orca14/appointmodv2?class=01";
/*
      class :01 予約
            :02 取消

      1.患者番号         Patient_ID              (REQUIRED)
      2.予約氏名         WholeName               (REQUIRED)
      3.カナ氏名         WholeName_inKane        (REQUIRED)
      4.予約日           Appointment_Date        (REQUIRED)
      5.予約時間         Appointment_Time        (REQUIRED)
      6.予約ID           Appointment_Id          (IMPLIED)
      7.診療科           Department_Code         (REQUIRED)
      8.ドクターコード   Physician_Code          (REQUIRED)
      9.診療内容区分     Medical_Information     (IMPLIED)
      10.予約内容区分    Appointment_Information (IMPLIED)
      11.予約コメント    Appointment_Note        (IMPLIED)

      REQUIRED : 必須   IMPLIED : 任意
*/

      string BODY = @"
<data>
	<appointreq type=""record"">
		<Patient_ID type=""string"">44444</Patient_ID>
		<Appointment_Date type=""string"">2012-07-19</Appointment_Date>
		<Appointment_Time type=""string"">12:10:00</Appointment_Time>
		<Appointment_Id type=""string""></Appointment_Id>
		<Department_Code type=""string"">01</Department_Code>
		<Physician_Code type=""string"">10001</Physician_Code>
		<Medical_Information type=""string"">01</Medical_Information>
		<Appointment_Information type=""string""></Appointment_Information>
		<Appointment_Note type=""string"">予約めもです </Appointment_Note>
	</appointreq>
</data>
      ";

      byte[] record_in_byte = Encoding.UTF8.GetBytes(BODY);

      HttpWebRequest req = (HttpWebRequest) HttpWebRequest.Create(URL);
      //req.ProtocolVersion = HttpVersion.Version11;

      req.Method = "POST";
      req.ContentType = CONTENT_TYPE;
      req.ContentLength = record_in_byte.Length;
      req.Credentials = new NetworkCredential(USER, PASSWD);

      Console.WriteLine(BODY);

      HttpWebResponse res = null;
      try
      {
        Stream reqstream = req.GetRequestStream();

        reqstream.Write(record_in_byte, 0, record_in_byte.Length);
        reqstream.Close();

        res = (HttpWebResponse) req.GetResponse();

        Console.WriteLine(res.ResponseUri);
        Console.WriteLine(res.StatusDescription);
      }
      catch (WebException exc)
      {
        if (exc.Status == WebExceptionStatus.ProtocolError)
        {
          HttpWebResponse err = (HttpWebResponse) exc.Response;

          int errcode = (int) err.StatusCode;

          Console.WriteLine(err.ResponseUri);
          Console.WriteLine("{0}:{1}", errcode, err.StatusDescription);

          err.Close();
        }
        else
        {
          Console.WriteLine(exc.Message);
        }
      }

      if (res != null)
      {
        Stream str = res.GetResponseStream();
        StreamReader strread = new StreamReader(str);

        string FOO = strread.ReadToEnd();
        string FILE_NAME = "foo.xml";
        File.WriteAllText(FILE_NAME, FOO);

        strread.Close();
        str.Close();

        res.Close();
      }
    }
  }
}
